<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_67) on Wed Sep 10 14:57:28 CEST 2014 -->
<title>WebSocketClient</title>
<meta name="date" content="2014-09-10">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="WebSocketClient";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/WebSocketClient.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/java_websocket/client/AbstractClientProxyChannel.html" title="class in org.java_websocket.client"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/java_websocket/client/WebSocketClient.WebsocketWriteThread.html" title="class in org.java_websocket.client"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/java_websocket/client/WebSocketClient.html" target="_top">Frames</a></li>
<li><a href="WebSocketClient.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.java_websocket.client</div>
<h2 title="Class WebSocketClient" class="title">Class WebSocketClient</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">org.java_websocket.WebSocketAdapter</a></li>
<li>
<ul class="inheritance">
<li>org.java_websocket.client.WebSocketClient</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.lang.Runnable, <a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>, <a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></dd>
</dl>
<hr>
<br>
<pre>public abstract class <span class="strong">WebSocketClient</span>
extends <a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">WebSocketAdapter</a>
implements java.lang.Runnable, <a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></pre>
<div class="block">A subclass must implement at least <var>onOpen</var>, <var>onClose</var>, and <var>onMessage</var> to be
 useful. At runtime the user is expected to establish a connection via <a href="../../../org/java_websocket/client/WebSocketClient.html#connect()"><code>connect()</code></a>, then receive events like <a href="../../../org/java_websocket/client/WebSocketClient.html#onMessage(java.lang.String)"><code>onMessage(String)</code></a> via the overloaded methods and to <a href="../../../org/java_websocket/client/WebSocketClient.html#send(java.lang.String)"><code>send(String)</code></a> data to the server.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Class and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private class&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.WebsocketWriteThread.html" title="class in org.java_websocket.client">WebSocketClient.WebsocketWriteThread</a></strong></code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="nested_classes_inherited_from_class_org.java_websocket.WebSocket">
<!--   -->
</a>
<h3>Nested classes/interfaces inherited from interface&nbsp;org.java_websocket.<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></h3>
<code><a href="../../../org/java_websocket/WebSocket.READYSTATE.html" title="enum in org.java_websocket">WebSocket.READYSTATE</a>, <a href="../../../org/java_websocket/WebSocket.Role.html" title="enum in org.java_websocket">WebSocket.Role</a></code></li>
</ul>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.concurrent.CountDownLatch</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#closeLatch">closeLatch</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.concurrent.CountDownLatch</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#connectLatch">connectLatch</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#connectTimeout">connectTimeout</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#draft">draft</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../../org/java_websocket/WebSocketImpl.html" title="class in org.java_websocket">WebSocketImpl</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#engine">engine</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.Map&lt;java.lang.String,java.lang.String&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#headers">headers</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.io.InputStream</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#istream">istream</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.io.OutputStream</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#ostream">ostream</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.net.Proxy</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#proxy">proxy</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.net.Socket</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#socket">socket</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.net.URI</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#uri">uri</a></strong></code>
<div class="block">The URI this channel is supposed to connect to.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.lang.Thread</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#writeThread">writeThread</a></strong></code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="fields_inherited_from_class_org.java_websocket.WebSocket">
<!--   -->
</a>
<h3>Fields inherited from interface&nbsp;org.java_websocket.<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></h3>
<code><a href="../../../org/java_websocket/WebSocket.html#DEFAULT_PORT">DEFAULT_PORT</a>, <a href="../../../org/java_websocket/WebSocket.html#DEFAULT_WSS_PORT">DEFAULT_WSS_PORT</a></code></li>
</ul>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#WebSocketClient(java.net.URI)">WebSocketClient</a></strong>(java.net.URI&nbsp;serverURI)</code>
<div class="block">This open a websocket connection as specified by rfc6455</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#WebSocketClient(java.net.URI,%20org.java_websocket.drafts.Draft)">WebSocketClient</a></strong>(java.net.URI&nbsp;serverUri,
               <a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft)</code>
<div class="block">Constructs a WebSocketClient instance and sets it to the connect to the
 specified URI.</div>
</td>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#WebSocketClient(java.net.URI,%20org.java_websocket.drafts.Draft,%20java.util.Map,%20int)">WebSocketClient</a></strong>(java.net.URI&nbsp;serverUri,
               <a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;protocolDraft,
               java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;httpHeaders,
               int&nbsp;connectTimeout)</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#close()">close</a></strong>()</code>
<div class="block">Initiates the websocket close handshake.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#close(int)">close</a></strong>(int&nbsp;code)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#close(int,%20java.lang.String)">close</a></strong>(int&nbsp;code,
     java.lang.String&nbsp;message)</code>
<div class="block">sends the closing handshake.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#closeBlocking()">closeBlocking</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#closeConnection(int,%20java.lang.String)">closeConnection</a></strong>(int&nbsp;code,
               java.lang.String&nbsp;message)</code>
<div class="block">This will close the connection immediately without a proper close handshake.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#connect()">connect</a></strong>()</code>
<div class="block">Initiates the websocket connection.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#connectBlocking()">connectBlocking</a></strong>()</code>
<div class="block">Same as <code>connect</code> but blocks until the websocket connected or failed to do so.<br>
 Returns whether it succeeded or not.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getConnection()">getConnection</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getDraft()">getDraft</a></strong>()</code>
<div class="block">Returns the protocol version this channel uses.<br>
 For more infos see https://github.com/TooTallNate/Java-WebSocket/wiki/Drafts</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getLocalSocketAddress()">getLocalSocketAddress</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getLocalSocketAddress(org.java_websocket.WebSocket)">getLocalSocketAddress</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getPort()">getPort</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../org/java_websocket/WebSocket.READYSTATE.html" title="enum in org.java_websocket">WebSocket.READYSTATE</a></code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getReadyState()">getReadyState</a></strong>()</code>
<div class="block">This represents the state of the connection.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getRemoteSocketAddress()">getRemoteSocketAddress</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.net.InetSocketAddress</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getRemoteSocketAddress(org.java_websocket.WebSocket)">getRemoteSocketAddress</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getResourceDescriptor()">getResourceDescriptor</a></strong>()</code>
<div class="block">Returns the HTTP Request-URI as defined by http://tools.ietf.org/html/rfc2616#section-5.1.2<br>
 If the opening handshake has not yet happened it will return null.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.net.URI</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#getURI()">getURI</a></strong>()</code>
<div class="block">Returns the URI that this WebSocketClient is connected to.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#hasBufferedData()">hasBufferedData</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#isClosed()">isClosed</a></strong>()</code>
<div class="block">Returns whether the close handshake has been completed and the socket is closed.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#isClosing()">isClosing</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#isConnecting()">isConnecting</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#isFlushAndClose()">isFlushAndClose</a></strong>()</code>
<div class="block">Returns true when no further frames may be submitted<br>
 This happens before the socket connection is closed.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#isOpen()">isOpen</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onClose(int,%20java.lang.String,%20boolean)">onClose</a></strong>(int&nbsp;code,
       java.lang.String&nbsp;reason,
       boolean&nbsp;remote)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onCloseInitiated(int,%20java.lang.String)">onCloseInitiated</a></strong>(int&nbsp;code,
                java.lang.String&nbsp;reason)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onClosing(int,%20java.lang.String,%20boolean)">onClosing</a></strong>(int&nbsp;code,
         java.lang.String&nbsp;reason,
         boolean&nbsp;remote)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onError(java.lang.Exception)">onError</a></strong>(java.lang.Exception&nbsp;ex)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onFragment(org.java_websocket.framing.Framedata)">onFragment</a></strong>(<a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;frame)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onMessage(java.nio.ByteBuffer)">onMessage</a></strong>(java.nio.ByteBuffer&nbsp;bytes)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onMessage(java.lang.String)">onMessage</a></strong>(java.lang.String&nbsp;message)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>abstract void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onOpen(org.java_websocket.handshake.ServerHandshake)">onOpen</a></strong>(<a href="../../../org/java_websocket/handshake/ServerHandshake.html" title="interface in org.java_websocket.handshake">ServerHandshake</a>&nbsp;handshakedata)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWebsocketClose(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClose</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                int&nbsp;code,
                java.lang.String&nbsp;reason,
                boolean&nbsp;remote)</code>
<div class="block">Calls subclass' implementation of <var>onClose</var>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWebsocketCloseInitiated(org.java_websocket.WebSocket,%20int,%20java.lang.String)">onWebsocketCloseInitiated</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                         int&nbsp;code,
                         java.lang.String&nbsp;reason)</code>
<div class="block">send when this peer sends a close handshake</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWebsocketClosing(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClosing</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                  int&nbsp;code,
                  java.lang.String&nbsp;reason,
                  boolean&nbsp;remote)</code>
<div class="block">called as soon as no further frames are accepted</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWebsocketError(org.java_websocket.WebSocket,%20java.lang.Exception)">onWebsocketError</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                java.lang.Exception&nbsp;ex)</code>
<div class="block">Calls subclass' implementation of <var>onIOError</var>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)">onWebsocketMessage</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                  java.nio.ByteBuffer&nbsp;blob)</code>
<div class="block">Called when an entire binary frame has been received.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.lang.String)">onWebsocketMessage</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                  java.lang.String&nbsp;message)</code>
<div class="block">Calls subclass' implementation of <var>onMessage</var>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketMessageFragment</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                          <a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;frame)</code>
<div class="block">This default implementation does not do anything.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWebsocketOpen(org.java_websocket.WebSocket,%20org.java_websocket.handshake.Handshakedata)">onWebsocketOpen</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
               <a href="../../../org/java_websocket/handshake/Handshakedata.html" title="interface in org.java_websocket.handshake">Handshakedata</a>&nbsp;handshake)</code>
<div class="block">Calls subclass' implementation of <var>onOpen</var>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#onWriteDemand(org.java_websocket.WebSocket)">onWriteDemand</a></strong>(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</code>
<div class="block">This method is used to inform the selector thread that there is data queued to be written to the socket.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#run()">run</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#send(byte[])">send</a></strong>(byte[]&nbsp;data)</code>
<div class="block">Sends binary <var> data</var> to the connected webSocket server.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#send(java.nio.ByteBuffer)">send</a></strong>(java.nio.ByteBuffer&nbsp;bytes)</code>
<div class="block">Send Binary data (plain bytes) to the other end.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#send(java.lang.String)">send</a></strong>(java.lang.String&nbsp;text)</code>
<div class="block">Sends <var>text</var> to the connected websocket server.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode,%20java.nio.ByteBuffer,%20boolean)">sendFragmentedFrame</a></strong>(<a href="../../../org/java_websocket/framing/Framedata.Opcode.html" title="enum in org.java_websocket.framing">Framedata.Opcode</a>&nbsp;op,
                   java.nio.ByteBuffer&nbsp;buffer,
                   boolean&nbsp;fin)</code>
<div class="block">Allows to send continuous/fragmented frames conveniently.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#sendFrame(org.java_websocket.framing.Framedata)">sendFrame</a></strong>(<a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;framedata)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#sendHandshake()">sendHandshake</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#setProxy(java.net.Proxy)">setProxy</a></strong>(java.net.Proxy&nbsp;proxy)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/client/WebSocketClient.html#setSocket(java.net.Socket)">setSocket</a></strong>(java.net.Socket&nbsp;socket)</code>
<div class="block">Accepts bound and unbound sockets.<br>
 This method must be called before <code>connect</code>.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.java_websocket.WebSocketAdapter">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;org.java_websocket.<a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">WebSocketAdapter</a></h3>
<code><a href="../../../org/java_websocket/WebSocketAdapter.html#getFlashPolicy(org.java_websocket.WebSocket)">getFlashPolicy</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketHandshakeReceivedAsClient(org.java_websocket.WebSocket,%20org.java_websocket.handshake.ClientHandshake,%20org.java_websocket.handshake.ServerHandshake)">onWebsocketHandshakeReceivedAsClient</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketHandshakeReceivedAsServer(org.java_websocket.WebSocket,%20org.java_websocket.drafts.Draft,%20org.java_websocket.handshake.ClientHandshake)">onWebsocketHandshakeReceivedAsServer</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketHandshakeSentAsClient(org.java_websocket.WebSocket,%20org.java_websocket.handshake.ClientHandshake)">onWebsocketHandshakeSentAsClient</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketPing(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketPing</a>, <a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketPong(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketPong</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="uri">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>uri</h4>
<pre>protected&nbsp;java.net.URI uri</pre>
<div class="block">The URI this channel is supposed to connect to.</div>
</li>
</ul>
<a name="engine">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>engine</h4>
<pre>private&nbsp;<a href="../../../org/java_websocket/WebSocketImpl.html" title="class in org.java_websocket">WebSocketImpl</a> engine</pre>
</li>
</ul>
<a name="socket">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>socket</h4>
<pre>private&nbsp;java.net.Socket socket</pre>
</li>
</ul>
<a name="istream">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>istream</h4>
<pre>private&nbsp;java.io.InputStream istream</pre>
</li>
</ul>
<a name="ostream">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>ostream</h4>
<pre>private&nbsp;java.io.OutputStream ostream</pre>
</li>
</ul>
<a name="proxy">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>proxy</h4>
<pre>private&nbsp;java.net.Proxy proxy</pre>
</li>
</ul>
<a name="writeThread">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeThread</h4>
<pre>private&nbsp;java.lang.Thread writeThread</pre>
</li>
</ul>
<a name="draft">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>draft</h4>
<pre>private&nbsp;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a> draft</pre>
</li>
</ul>
<a name="headers">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>headers</h4>
<pre>private&nbsp;java.util.Map&lt;java.lang.String,java.lang.String&gt; headers</pre>
</li>
</ul>
<a name="connectLatch">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>connectLatch</h4>
<pre>private&nbsp;java.util.concurrent.CountDownLatch connectLatch</pre>
</li>
</ul>
<a name="closeLatch">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeLatch</h4>
<pre>private&nbsp;java.util.concurrent.CountDownLatch closeLatch</pre>
</li>
</ul>
<a name="connectTimeout">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>connectTimeout</h4>
<pre>private&nbsp;int connectTimeout</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="WebSocketClient(java.net.URI)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketClient</h4>
<pre>public&nbsp;WebSocketClient(java.net.URI&nbsp;serverURI)</pre>
<div class="block">This open a websocket connection as specified by rfc6455</div>
</li>
</ul>
<a name="WebSocketClient(java.net.URI, org.java_websocket.drafts.Draft)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WebSocketClient</h4>
<pre>public&nbsp;WebSocketClient(java.net.URI&nbsp;serverUri,
               <a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;draft)</pre>
<div class="block">Constructs a WebSocketClient instance and sets it to the connect to the
 specified URI. The channel does not attampt to connect automatically. The connection
 will be established once you call <var>connect</var>.</div>
</li>
</ul>
<a name="WebSocketClient(java.net.URI, org.java_websocket.drafts.Draft, java.util.Map, int)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>WebSocketClient</h4>
<pre>public&nbsp;WebSocketClient(java.net.URI&nbsp;serverUri,
               <a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;protocolDraft,
               java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;httpHeaders,
               int&nbsp;connectTimeout)</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getURI()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getURI</h4>
<pre>public&nbsp;java.net.URI&nbsp;getURI()</pre>
<div class="block">Returns the URI that this WebSocketClient is connected to.</div>
</li>
</ul>
<a name="getDraft()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDraft</h4>
<pre>public&nbsp;<a href="../../../org/java_websocket/drafts/Draft.html" title="class in org.java_websocket.drafts">Draft</a>&nbsp;getDraft()</pre>
<div class="block">Returns the protocol version this channel uses.<br>
 For more infos see https://github.com/TooTallNate/Java-WebSocket/wiki/Drafts</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#getDraft()">getDraft</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="connect()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>connect</h4>
<pre>public&nbsp;void&nbsp;connect()</pre>
<div class="block">Initiates the websocket connection. This method does not block.</div>
</li>
</ul>
<a name="connectBlocking()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>connectBlocking</h4>
<pre>public&nbsp;boolean&nbsp;connectBlocking()
                        throws java.lang.InterruptedException</pre>
<div class="block">Same as <code>connect</code> but blocks until the websocket connected or failed to do so.<br>
 Returns whether it succeeded or not.</div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="close()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close()</pre>
<div class="block">Initiates the websocket close handshake. This method does not block<br>
 In oder to make sure the connection is closed use <code>closeBlocking</code></div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#close()">close</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="closeBlocking()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeBlocking</h4>
<pre>public&nbsp;void&nbsp;closeBlocking()
                   throws java.lang.InterruptedException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.InterruptedException</code></dd></dl>
</li>
</ul>
<a name="send(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>send</h4>
<pre>public&nbsp;void&nbsp;send(java.lang.String&nbsp;text)
          throws java.nio.channels.NotYetConnectedException</pre>
<div class="block">Sends <var>text</var> to the connected websocket server.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#send(java.lang.String)">send</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>text</code> - The string which will be transmitted.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.nio.channels.NotYetConnectedException</code></dd></dl>
</li>
</ul>
<a name="send(byte[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>send</h4>
<pre>public&nbsp;void&nbsp;send(byte[]&nbsp;data)
          throws java.nio.channels.NotYetConnectedException</pre>
<div class="block">Sends binary <var> data</var> to the connected webSocket server.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#send(byte[])">send</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>data</code> - The byte-Array of data to send to the WebSocket server.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.nio.channels.NotYetConnectedException</code></dd></dl>
</li>
</ul>
<a name="run()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>run</h4>
<pre>public&nbsp;void&nbsp;run()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>run</code>&nbsp;in interface&nbsp;<code>java.lang.Runnable</code></dd>
</dl>
</li>
</ul>
<a name="getPort()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPort</h4>
<pre>private&nbsp;int&nbsp;getPort()</pre>
</li>
</ul>
<a name="sendHandshake()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sendHandshake</h4>
<pre>private&nbsp;void&nbsp;sendHandshake()
                    throws <a href="../../../org/java_websocket/exceptions/InvalidHandshakeException.html" title="class in org.java_websocket.exceptions">InvalidHandshakeException</a></pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../org/java_websocket/exceptions/InvalidHandshakeException.html" title="class in org.java_websocket.exceptions">InvalidHandshakeException</a></code></dd></dl>
</li>
</ul>
<a name="getReadyState()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getReadyState</h4>
<pre>public&nbsp;<a href="../../../org/java_websocket/WebSocket.READYSTATE.html" title="enum in org.java_websocket">WebSocket.READYSTATE</a>&nbsp;getReadyState()</pre>
<div class="block">This represents the state of the connection.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#getReadyState()">getReadyState</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Returns:</span></dt><dd>Returns '0 = CONNECTING', '1 = OPEN', '2 = CLOSING' or '3 = CLOSED'</dd></dl>
</li>
</ul>
<a name="onWebsocketMessage(org.java_websocket.WebSocket, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessage</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketMessage(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                      java.lang.String&nbsp;message)</pre>
<div class="block">Calls subclass' implementation of <var>onMessage</var>.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.lang.String)">onWebsocketMessage</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occurring on.</dd><dd><code>message</code> - The UTF-8 decoded message that was received.</dd></dl>
</li>
</ul>
<a name="onWebsocketMessage(org.java_websocket.WebSocket, java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessage</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketMessage(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                      java.nio.ByteBuffer&nbsp;blob)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)">WebSocketListener</a></code></strong></div>
<div class="block">Called when an entire binary frame has been received. Do whatever you want
 here...</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessage(org.java_websocket.WebSocket,%20java.nio.ByteBuffer)">onWebsocketMessage</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occurring on.</dd><dd><code>blob</code> - The binary message that was received.</dd></dl>
</li>
</ul>
<a name="onWebsocketMessageFragment(org.java_websocket.WebSocket, org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketMessageFragment</h4>
<pre>public&nbsp;void&nbsp;onWebsocketMessageFragment(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                              <a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;frame)</pre>
<div class="block"><strong>Description copied from class:&nbsp;<code><a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">WebSocketAdapter</a></code></strong></div>
<div class="block">This default implementation does not do anything. Go ahead and overwrite it</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketMessageFragment</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><strong>Overrides:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketAdapter.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)">onWebsocketMessageFragment</a></code>&nbsp;in class&nbsp;<code><a href="../../../org/java_websocket/WebSocketAdapter.html" title="class in org.java_websocket">WebSocketAdapter</a></code></dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketMessageFragment(org.java_websocket.WebSocket,%20org.java_websocket.framing.Framedata)"><code>WebSocketListener.onWebsocketMessageFragment(WebSocket, Framedata)</code></a></dd></dl>
</li>
</ul>
<a name="onWebsocketOpen(org.java_websocket.WebSocket, org.java_websocket.handshake.Handshakedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketOpen</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketOpen(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                   <a href="../../../org/java_websocket/handshake/Handshakedata.html" title="interface in org.java_websocket.handshake">Handshakedata</a>&nbsp;handshake)</pre>
<div class="block">Calls subclass' implementation of <var>onOpen</var>.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketOpen(org.java_websocket.WebSocket,%20org.java_websocket.handshake.Handshakedata)">onWebsocketOpen</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>conn</code> - The <tt>WebSocket</tt> instance this event is occuring on.</dd></dl>
</li>
</ul>
<a name="onWebsocketClose(org.java_websocket.WebSocket, int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketClose</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketClose(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                    int&nbsp;code,
                    java.lang.String&nbsp;reason,
                    boolean&nbsp;remote)</pre>
<div class="block">Calls subclass' implementation of <var>onClose</var>.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketClose(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClose</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onWebsocketError(org.java_websocket.WebSocket, java.lang.Exception)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketError</h4>
<pre>public final&nbsp;void&nbsp;onWebsocketError(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                    java.lang.Exception&nbsp;ex)</pre>
<div class="block">Calls subclass' implementation of <var>onIOError</var>.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketError(org.java_websocket.WebSocket,%20java.lang.Exception)">onWebsocketError</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
<dd><code>ex</code> - The exception that occurred. <br>
            Might be null if the exception is not related to any specific connection. For example if the server port could not be bound.</dd></dl>
</li>
</ul>
<a name="onWriteDemand(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWriteDemand</h4>
<pre>public final&nbsp;void&nbsp;onWriteDemand(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWriteDemand(org.java_websocket.WebSocket)">WebSocketListener</a></code></strong></div>
<div class="block">This method is used to inform the selector thread that there is data queued to be written to the socket.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWriteDemand(org.java_websocket.WebSocket)">onWriteDemand</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onWebsocketCloseInitiated(org.java_websocket.WebSocket, int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketCloseInitiated</h4>
<pre>public&nbsp;void&nbsp;onWebsocketCloseInitiated(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                             int&nbsp;code,
                             java.lang.String&nbsp;reason)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketCloseInitiated(org.java_websocket.WebSocket,%20int,%20java.lang.String)">WebSocketListener</a></code></strong></div>
<div class="block">send when this peer sends a close handshake</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketCloseInitiated(org.java_websocket.WebSocket,%20int,%20java.lang.String)">onWebsocketCloseInitiated</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onWebsocketClosing(org.java_websocket.WebSocket, int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onWebsocketClosing</h4>
<pre>public&nbsp;void&nbsp;onWebsocketClosing(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn,
                      int&nbsp;code,
                      java.lang.String&nbsp;reason,
                      boolean&nbsp;remote)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketClosing(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">WebSocketListener</a></code></strong></div>
<div class="block">called as soon as no further frames are accepted</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#onWebsocketClosing(org.java_websocket.WebSocket,%20int,%20java.lang.String,%20boolean)">onWebsocketClosing</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onCloseInitiated(int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onCloseInitiated</h4>
<pre>public&nbsp;void&nbsp;onCloseInitiated(int&nbsp;code,
                    java.lang.String&nbsp;reason)</pre>
</li>
</ul>
<a name="onClosing(int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onClosing</h4>
<pre>public&nbsp;void&nbsp;onClosing(int&nbsp;code,
             java.lang.String&nbsp;reason,
             boolean&nbsp;remote)</pre>
</li>
</ul>
<a name="getConnection()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConnection</h4>
<pre>public&nbsp;<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;getConnection()</pre>
</li>
</ul>
<a name="getLocalSocketAddress(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLocalSocketAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getLocalSocketAddress(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#getLocalSocketAddress(org.java_websocket.WebSocket)">getLocalSocketAddress</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="getRemoteSocketAddress(org.java_websocket.WebSocket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRemoteSocketAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getRemoteSocketAddress(<a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a>&nbsp;conn)</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocketListener.html#getRemoteSocketAddress(org.java_websocket.WebSocket)">getRemoteSocketAddress</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocketListener.html" title="interface in org.java_websocket">WebSocketListener</a></code></dd>
</dl>
</li>
</ul>
<a name="onOpen(org.java_websocket.handshake.ServerHandshake)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onOpen</h4>
<pre>public abstract&nbsp;void&nbsp;onOpen(<a href="../../../org/java_websocket/handshake/ServerHandshake.html" title="interface in org.java_websocket.handshake">ServerHandshake</a>&nbsp;handshakedata)</pre>
</li>
</ul>
<a name="onMessage(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onMessage</h4>
<pre>public abstract&nbsp;void&nbsp;onMessage(java.lang.String&nbsp;message)</pre>
</li>
</ul>
<a name="onClose(int, java.lang.String, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onClose</h4>
<pre>public abstract&nbsp;void&nbsp;onClose(int&nbsp;code,
           java.lang.String&nbsp;reason,
           boolean&nbsp;remote)</pre>
</li>
</ul>
<a name="onError(java.lang.Exception)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onError</h4>
<pre>public abstract&nbsp;void&nbsp;onError(java.lang.Exception&nbsp;ex)</pre>
</li>
</ul>
<a name="onMessage(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onMessage</h4>
<pre>public&nbsp;void&nbsp;onMessage(java.nio.ByteBuffer&nbsp;bytes)</pre>
</li>
</ul>
<a name="onFragment(org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>onFragment</h4>
<pre>public&nbsp;void&nbsp;onFragment(<a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;frame)</pre>
</li>
</ul>
<a name="setProxy(java.net.Proxy)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setProxy</h4>
<pre>public&nbsp;void&nbsp;setProxy(java.net.Proxy&nbsp;proxy)</pre>
</li>
</ul>
<a name="setSocket(java.net.Socket)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setSocket</h4>
<pre>public&nbsp;void&nbsp;setSocket(java.net.Socket&nbsp;socket)</pre>
<div class="block">Accepts bound and unbound sockets.<br>
 This method must be called before <code>connect</code>.
 If the given socket is not yet bound it will be bound to the uri specified in the constructor.</div>
</li>
</ul>
<a name="sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode, java.nio.ByteBuffer, boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sendFragmentedFrame</h4>
<pre>public&nbsp;void&nbsp;sendFragmentedFrame(<a href="../../../org/java_websocket/framing/Framedata.Opcode.html" title="enum in org.java_websocket.framing">Framedata.Opcode</a>&nbsp;op,
                       java.nio.ByteBuffer&nbsp;buffer,
                       boolean&nbsp;fin)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html#sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode,%20java.nio.ByteBuffer,%20boolean)">WebSocket</a></code></strong></div>
<div class="block">Allows to send continuous/fragmented frames conveniently. <br>
 For more into on this frame type see http://tools.ietf.org/html/rfc6455#section-5.4<br>
 
 If the first frame you send is also the last then it is not a fragmented frame and will received via onMessage instead of onFragmented even though it was send by this method.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#sendFragmentedFrame(org.java_websocket.framing.Framedata.Opcode,%20java.nio.ByteBuffer,%20boolean)">sendFragmentedFrame</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Parameters:</span></dt><dd><code>op</code> - This is only important for the first frame in the sequence. Opcode.TEXT, Opcode.BINARY are allowed.</dd><dd><code>buffer</code> - The buffer which contains the payload. It may have no bytes remaining.</dd><dd><code>fin</code> - true means the current frame is the last in the sequence.</dd></dl>
</li>
</ul>
<a name="isOpen()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isOpen</h4>
<pre>public&nbsp;boolean&nbsp;isOpen()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#isOpen()">isOpen</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isFlushAndClose()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isFlushAndClose</h4>
<pre>public&nbsp;boolean&nbsp;isFlushAndClose()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html#isFlushAndClose()">WebSocket</a></code></strong></div>
<div class="block">Returns true when no further frames may be submitted<br>
 This happens before the socket connection is closed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#isFlushAndClose()">isFlushAndClose</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isClosed()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isClosed</h4>
<pre>public&nbsp;boolean&nbsp;isClosed()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html#isClosed()">WebSocket</a></code></strong></div>
<div class="block">Returns whether the close handshake has been completed and the socket is closed.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#isClosed()">isClosed</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isClosing()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isClosing</h4>
<pre>public&nbsp;boolean&nbsp;isClosing()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#isClosing()">isClosing</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="isConnecting()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isConnecting</h4>
<pre>public&nbsp;boolean&nbsp;isConnecting()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#isConnecting()">isConnecting</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="hasBufferedData()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasBufferedData</h4>
<pre>public&nbsp;boolean&nbsp;hasBufferedData()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#hasBufferedData()">hasBufferedData</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="close(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close(int&nbsp;code)</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#close(int)">close</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="close(int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close(int&nbsp;code,
         java.lang.String&nbsp;message)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html#close(int,%20java.lang.String)">WebSocket</a></code></strong></div>
<div class="block">sends the closing handshake.
 may be send in response to an other handshake.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#close(int,%20java.lang.String)">close</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="closeConnection(int, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeConnection</h4>
<pre>public&nbsp;void&nbsp;closeConnection(int&nbsp;code,
                   java.lang.String&nbsp;message)</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html#closeConnection(int,%20java.lang.String)">WebSocket</a></code></strong></div>
<div class="block">This will close the connection immediately without a proper close handshake.
 The code and the message therefore won't be transfered over the wire also they will be forwarded to onClose/onWebsocketClose.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#closeConnection(int,%20java.lang.String)">closeConnection</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="send(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>send</h4>
<pre>public&nbsp;void&nbsp;send(java.nio.ByteBuffer&nbsp;bytes)
          throws java.lang.IllegalArgumentException,
                 java.nio.channels.NotYetConnectedException</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html#send(java.nio.ByteBuffer)">WebSocket</a></code></strong></div>
<div class="block">Send Binary data (plain bytes) to the other end.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#send(java.nio.ByteBuffer)">send</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.IllegalArgumentException</code></dd>
<dd><code>java.nio.channels.NotYetConnectedException</code></dd></dl>
</li>
</ul>
<a name="sendFrame(org.java_websocket.framing.Framedata)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sendFrame</h4>
<pre>public&nbsp;void&nbsp;sendFrame(<a href="../../../org/java_websocket/framing/Framedata.html" title="interface in org.java_websocket.framing">Framedata</a>&nbsp;framedata)</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#sendFrame(org.java_websocket.framing.Framedata)">sendFrame</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="getLocalSocketAddress()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLocalSocketAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getLocalSocketAddress()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#getLocalSocketAddress()">getLocalSocketAddress</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="getRemoteSocketAddress()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRemoteSocketAddress</h4>
<pre>public&nbsp;java.net.InetSocketAddress&nbsp;getRemoteSocketAddress()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#getRemoteSocketAddress()">getRemoteSocketAddress</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
<a name="getResourceDescriptor()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getResourceDescriptor</h4>
<pre>public&nbsp;java.lang.String&nbsp;getResourceDescriptor()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html#getResourceDescriptor()">WebSocket</a></code></strong></div>
<div class="block">Returns the HTTP Request-URI as defined by http://tools.ietf.org/html/rfc2616#section-5.1.2<br>
 If the opening handshake has not yet happened it will return null.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../../org/java_websocket/WebSocket.html#getResourceDescriptor()">getResourceDescriptor</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket">WebSocket</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/WebSocketClient.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/java_websocket/client/AbstractClientProxyChannel.html" title="class in org.java_websocket.client"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/java_websocket/client/WebSocketClient.WebsocketWriteThread.html" title="class in org.java_websocket.client"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/java_websocket/client/WebSocketClient.html" target="_top">Frames</a></li>
<li><a href="WebSocketClient.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
